#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include <assert.h>
#include "resource.h"
#include "defblib.h"

void setDialogTitle( HWND hwnd ) {
    static int nDlgNo = 0;
    TCHAR szTitle[ 100 ] = { 0 };
    wsprintf( szTitle, _T( "Dialog #%d" ), ++nDlgNo );
    SetWindowText( hwnd, szTitle );
}

BOOL CALLBACK 
dlgFn1( HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam ) {
    int  id         = GET_WM_COMMAND_ID  ( wParam, lParam );
    int  codeNotify = GET_WM_COMMAND_CMD ( wParam, lParam );
    HWND hwndOK     = GetDlgItem( hwnd, IDC_OK   );
    HWND hwndEnable = GetDlgItem( hwnd, IDC_ENABLED );
    
    switch ( msg ) {
    case WM_INITDIALOG:
        Button_SetCheck( hwndEnable, 1 );
        setDialogTitle( hwnd );
        return TRUE;
        
    case WM_COMMAND:
        if ( BN_CLICKED == codeNotify ) {
            if ( IDC_ENABLED == id ) {
                BOOL bEnable = Button_GetCheck( hwndEnable );
                EnableWindow( hwndOK, bEnable );
            } else if ( IDC_OK == id ) {;
                EnableWindow( hwndOK, FALSE );
                Button_SetCheck( hwndEnable, 0 );
            } else if ( IDCANCEL == id ) {;
                EndDialog( hwnd, IDCANCEL );
            }
        }
        return TRUE;
    }
    return FALSE;
}

BOOL CALLBACK 
dlgFn2( HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam ) {
    int  id         = GET_WM_COMMAND_ID  ( wParam, lParam );
    int  codeNotify = GET_WM_COMMAND_CMD ( wParam, lParam );
    HWND hwndCtl    = GET_WM_COMMAND_HWND( wParam, lParam );
    HWND hwndOK     = GetDlgItem( hwnd, IDC_OK   );
    
    switch ( msg ) {
    case WM_INITDIALOG:
        Button_SetCheck( GetDlgItem( hwnd, IDC_ENABLED ), 1 );
        setDialogTitle( hwnd );
        return TRUE;
        
    case WM_COMMAND:
        if ( CBN_DROPDOWN == codeNotify || 
             CBN_CLOSEUP  == codeNotify ) 
        {
            if ( CBN_DROPDOWN == codeNotify ) {
                Button_SetStyle( hwndOK, BS_PUSHBUTTON, TRUE );
            } else if ( IsWindowEnabled( hwndOK ) ) {
                Button_SetStyle( hwndOK, BS_DEFPUSHBUTTON, TRUE );
            }
        } else if ( BN_CLICKED == codeNotify ) {
            if ( IDC_ENABLED == id ) {
                const BOOL bEnable = Button_GetCheck( hwndCtl );
                EnableWindow( hwndOK, bEnable );
                SendMessage( hwnd, DM_SETDEFID, 
                    bEnable ? IDC_OK : 0, 0 );
                Button_SetStyle( hwndOK, bEnable 
                    ? BS_DEFPUSHBUTTON : BS_PUSHBUTTON, TRUE );
            } else if ( IDC_OK == id ) {
                const HWND hwndFocus = GetFocus();
                Button_SetStyle( hwndOK, BS_PUSHBUTTON, TRUE );
                EnableWindow( hwndOK, FALSE );
                CheckDlgButton( hwnd, IDC_ENABLED, 0 );
                if ( hwndFocus == hwndOK ) {
                  FORWARD_WM_NEXTDLGCTL( hwnd, 
                    GetDlgItem( hwnd, IDC_ENABLED ), TRUE, SNDMSG );
                }
            } else if ( IDCANCEL == id ) {
                EndDialog( hwnd, IDCANCEL );
            }
        } else if ( EN_KILLFOCUS == codeNotify ) {
            if ( IDC_EDIT == id ) {
                if ( IsWindowEnabled( hwndOK ) ) {
                    SendMessage( hwnd, DM_SETDEFID, IDC_OK, 0 );
                }
            }
        } else if ( EN_SETFOCUS == codeNotify ) {
            if ( IDC_EDIT == id ) {
                SendMessage( hwnd, DM_SETDEFID, 0, 0 );
                Button_SetStyle( hwndOK, BS_PUSHBUTTON, TRUE );
            }
        }
        return TRUE;
    }
    return FALSE;
}

int APIENTRY 
WinMain( HINSTANCE hinst, HINSTANCE h2, LPSTR psz, int nShow ) {
    OPENFILENAME openFileName = {
        sizeof( OPENFILENAME ), HWND_DESKTOP, hinst };
    DialogBox( hinst, _T( "DefBtnDlg" ), HWND_DESKTOP, dlgFn1 );
    DialogBox( hinst, _T( "DefBtnDlg" ), HWND_DESKTOP, dlgFn2 );
    fixDefBtns(); // Global subclassing of dialogs and statics
    DialogBox( hinst, _T( "DefBtnDlg" ), HWND_DESKTOP, dlgFn1 );
    GetOpenFileName( &openFileName );
    return 0;
}
